using System;
using System.Collections.Generic;
using System.Text;
using System.Data.OleDb;
using System.Collections;
using System.IO;
using SuperMap.Data;
using SuperMap.Mapping;
using SuperMap.Desktop;
using System.Data;
using System.Windows.Forms;

namespace SuperMap.Desktop.GPSTrackView
{
    public class ImportTrack : CtrlAction
    {
        static public Point2Ds pts = null;
        static public DataTable table;
        static public GeoLine trackLine;
        public ImportTrack(IBaseItem caller)
            : base(caller)
        {
        }
        public override void Run()
        {
            try
            {
                OpenFileDialog openFile = new OpenFileDialog();
                openFile.DefaultExt = "xls";
                if (openFile.ShowDialog() != DialogResult.OK)
                {
                    return;
                }
                String strExcelPath = openFile.FileName;
                SuperMap.Desktop.Application.ActiveApplication.Output.Output(strExcelPath);
                String ConnectionString = "Provider=Microsoft.Jet.Oledb.4.0;Data Source=" + strExcelPath + ";Extended Properties=Excel 8.0";
                
                //Import coordinates from Excel
                OleDbConnection connection = new OleDbConnection(ConnectionString);
                OleDbDataAdapter da = new OleDbDataAdapter("select * from [Sheet1$]", connection);
                DataSet ds = new DataSet();
                da.Fill(ds, "Book1");
                table = ds.Tables["Book1"];
                da.Dispose();
                ds.Dispose();
                connection.Close();
                pts = new Point2Ds();
                Point2D pnt = new Point2D();
                for (int p = 0; p < table.Rows.Count; p++)
                {
                    pnt.X = Convert.ToDouble(table.Rows[p][0].ToString());
                    pnt.Y = Convert.ToDouble(table.Rows[p][1].ToString());
                    pts.Add(pnt);
                }
                trackLine = new GeoLine();
                trackLine.AddPart(pts);
                GeoStyle pStyle = new GeoStyle();
                pStyle.LineColor = System.Drawing.Color.Red;
                pStyle.LineWidth = 2;
                trackLine.Style = pStyle;
                IFormMap formMap = Application.ActiveForm as IFormMap;

                //Add track line
                formMap.MapControl.Map.TrackingLayer.Add(trackLine, "GPSTrack"); 
                formMap.MapControl.Map.EnsureVisible(trackLine);
                formMap.MapControl.Map.Zoom(0.7);
                formMap.MapControl.Map.Refresh();              
                
            }
            catch (Exception)
            {
                SuperMap.Desktop.Application.ActiveApplication.Output.Output("Please check the coordnates in Excel");
            }


        }
   
    }
}
