using System;
using System.Collections.Generic;
using System.Text;
using SuperMap.Desktop;
using SuperMap.Data;
using SuperMap.Mapping;

namespace SuperMap.Desktop.GPSTrackView
{
    class PlayTrack: CtrlAction
    {
        static public System.Windows.Forms.Timer t = new System.Windows.Forms.Timer();
        static public bool bplay = false;
        
        int nPos = 0;
        IFormMap formMap = null;
        GeoStyle pStyle = new GeoStyle();
        Size2D size = new Size2D();

        public PlayTrack(IBaseItem caller)
            : base(caller)
        {
            formMap = Application.ActiveForm as IFormMap;
            t.Tick += new EventHandler(t_Tick);
            t.Interval = 200;

            //Set the size of the tracking layer
            size.Height = 10; 
            size.Width = 10;
        }

        void t_Tick(object sender, EventArgs e)
        {
            GeoPoint trackP = new GeoPoint();
            if (bplay == true && nPos < ImportTrack.pts.Count)
            {
               trackP.X = ImportTrack.pts[nPos].X;
               trackP.Y = ImportTrack.pts[nPos].Y;

               //0 indicates this object has not been added to the temporary layer
               if (nPos > 0) 
               {
                   formMap.MapControl.Map.TrackingLayer.Remove(1);
               }
               if (nPos + 1 < ImportTrack.pts.Count && ImportTrack.pts[nPos].X < ImportTrack.pts[nPos + 1].X)
               {
                   //Head right
                   pStyle.MarkerSymbolID = 54424;  
               }
               else
               {
                   //Head left
                   pStyle.MarkerSymbolID = 54423;  
               }
               pStyle.MarkerSize = size; 
               trackP.Style = pStyle; 
               formMap.MapControl.Map.TrackingLayer.Add(trackP, "GPSPoint");
               nPos++;
            }
            else
            {                
                nPos = 0;
                formMap.MapControl.Map.TrackingLayer.Remove(1);
            }
            formMap.MapControl.Map.RefreshTrackingLayer();
        }

        public override void Run()
        {
            //int nPos = 0;
            bplay = true;
            t.Enabled = true;            
        }

    }
}
